#! /usr/local/bin/perl

#this program requires three command line arguments:
#the first is the site name
#the second is the raw data file to be input  
#the third is the threshold for number of dst ips per src ip (>=)

$sitename = $ARGV[0];
$filter_dir = "/usr/local/logger/filters/";
$filterfile = $filter_dir . "find_scan." . $sitename . "_filter.getall";

$fileinraw = $ARGV[1];
open(INRAW,"$fileinraw");

$threshold = $ARGV[2];

$tcpdump_command = " gunzip -c ".$fileinraw."| tcpdump -r - -n -t -F ".$filterfile." > /tmp/filtered.data";
$sort_command = "sort -u /tmp/filtered.data";

print "Filtering raw data ... \n";
system($tcpdump_command);
close(INRAW);

print "Sorting filtered output ... \n";
open(SORTED,"$sort_command|");

$linenum = 0;
$old_dstoctets[0] = "x";
$old_dstoctets[1] = "x";
$old_dstoctets[2] = "x";
$old_dstoctets[3] = "x";
$oldsrcip = "x.x.x.x";

print "Searching for scans ....\n";

while(<SORTED>) 
{
    $line = $_;
    $linenum = $linenum + 1;
    @fields = split(/\s+/, $line);
    $srcip = @fields[0];
    $dstip = @fields[2];
    $founda = 0;
    $foundb = 0;
    $foundc = 0;
    $foundd = 0;
    $foundit = 0;
    
    @srcoctets = split(/\./,$srcip);
    $dum_srcip = $srcoctets[0].".".$srcoctets[1].".".$srcoctets[2].".".$srcoctets[3];
    $srcip = $dum_srcip;
    
    
    @dstoctets = split(/\./,$dstip);
    if ($dstoctets[3] =~ /:/)
    {
        @hold = split(/:/,$dstoctets[3]);
	$dum_octets3 = $hold[0];
	$dstoctets[3] = $dum_octets3;
    }
    $dum_dstip = $dstoctets[0].".".$dstoctets[1].".".$dstoctets[2].".".$dstoctets[3];
    $dstip = $dum_dstip;
    
   
       
        if ($srcip eq $oldsrcip)
        {   	                
	     foreach $keya (keys %{$srciphash{$srcip}} )
	     {
	        if ($dstoctets[0] eq $keya)
		{
		    $founda = 1;
		    
		      foreach $keyb (keys %{$srciphash{$srcip}{$keya}} )
		      {
		         if ($dstoctets[1] eq $keyb)
			 {
			     $foundb = 1;
			     
			         foreach $keyc (keys %{$srciphash{$srcip}{$keya}{$keyb}} )
				 {
				    if ($dstoctets[2] eq $keyc)
				    {
				        $foundc = 1;
					
					   foreach $keyd (keys %{$srciphash{$srcip}{$keya}{$keyb}{$keyc}} )
					   {
					       if ($dstoctets[3] eq $keyd)
					       {
					           $foundd = 1;
						   
						     $srciphash{$srcip}{$keya}{$keyb}{$keyc}{$keyd} += 1; 
						   
						   last;
					       }
					   }
					   if ($foundd == 0)
					   {
					      $keyd = $dstoctets[3];
					      $srciphash{$srcip}{$keya}{$keyb}{$keyc}{$keyd} = 1;
					   }
					
					last;
				    }
				 }
				 if ($foundc == 0)
				 {
				    $keyc = $dstoctets[2];
				    $keyd = $dstoctets[3];
				    $srciphash{$srcip}{$keya}{$keyb}{$keyc}{$keyd} = 1;
				 }
			     
			     last;
			 }
		      }
		      if ($foundb == 0)
		      {
		          $keyb = $dstoctets[1];
			  $keyc = $dstoctets[2];
			  $keyd = $dstoctets[3];
			  $srciphash{$srcip}{$keya}{$keyb}{$keyc}{$keyd} = 1;
		      }
		    
		    last;
		} 		
		
	     }
	     if ($founda == 0)
	     {
		   $keya = $dstoctets[0];
		   $keyb = $dstoctets[1];
		   $keyc = $dstoctets[2];
		   $keyd = $dstoctets[3];
		   $srciphash{$srcip}{$keya}{$keyb}{$keyc}{$keyd} = 1;		   		
	     }
        }  
        else
        {
            $keya = $dstoctets[0];
	    $keyb = $dstoctets[1];
	    $keyc = $dstoctets[2];
	    $keyd = $dstoctets[3];
	    $srciphash{$srcip}{$keya}{$keyb}{$keyc}{$keyd} = 1;
	    $oldsrcip = $srcip; 
        }
    

    if ($linenum%10000 == 0) {print "Line number ",$linenum," processed....\n";}
}
close(SORTED);



print "Analyzing output....\n";

foreach $srcip (keys(%srciphash))
{
   foreach $keya (keys %{$srciphash{$srcip}} )
   {
      foreach $keyb (keys %{$srciphash{$srcip}{$keya}} )
      {
         foreach $keyc (keys %{$srciphash{$srcip}{$keya}{$keyb}} )
	 {
	    foreach $keyd (keys %{$srciphash{$srcip}{$keya}{$keyb}{$keyc}} )
	    {
	        $dstip = $keya.".".$keyb.".".$keyc.".".$keyd;
		@dstiparray = (@dstiparray,$dstip);
		
		#print $srcip,"    ",$dstip,"\n";
	    }
	 }
      }
   }  
   
   $howmany = @dstiparray;
   $counthash{$srcip} = $howmany;

   @dstiparray = ();
   $howmany = 0;  
}

foreach $srcip (keys(%counthash))
{
    if ($counthash{$srcip} >= $threshold)
    {
       $outputhash{$srcip} = $counthash{$srcip};
    }
}

@sortedips = sort by_ip keys(%outputhash);



print "Writing output file .....\n";

$output_filename = "/tmp/" . $sitename . ".results";
open (OUT,">$output_filename");
printf(OUT "%-10s %-17s %-50s \n\n","num dests","source ip","source name");
foreach $srcip (@sortedips)
{
    @srcoctets = split(/\./, $srcip);
    $binip = pack "c4",$srcoctets[0],$srcoctets[1],$srcoctets[2],$srcoctets[3];
    @info = gethostbyaddr($binip,2);
    $srcname = $info[0];
    
    printf(OUT "%-10d %-17s %-50s \n", $outputhash{$srcip},$srcip,$srcname,"\n");
}
close(OUT);


print "Results are in file /tmp/", $sitename, ".results\n";




sub by_ip
{
    $IPa = $a;
    $IPb = $b;
    @avec = split(/\./ , $IPa);
    @bvec = split(/\./ , $IPb);

    if ($avec[0] < $bvec[0])
    {
        return -1;
    }
    elsif ($avec[0] > $bvec[0])
    {
        return 1;
    }
    elsif ($avec[0] == $bvec[0])
    {
        if ($avec[1] < $bvec[1])
        {
           return -1;
        }
        elsif ($avec[1] > $bvec[1])
        {
           return 1;
        }
        elsif ($avec[1] == $bvec[1])
        {
            if ($avec[2] < $bvec[2])
            {
               return -1;
            }
            elsif ($avec[2] > $bvec[2])
            {
               return 1;
            }
            elsif ($avec[2] == $bvec[2])
            {
                if ($avec[3] < $bvec[3])
                {
                    return -1;
                }
                elsif ($avec[3] > $bvec[3])
                {
                    return 1;
                }
                elsif ($avec[3] == $bvec[3])
                {
                    return 0;                   
                }
            }
        }
    }
}



