#!/usr/bin/perl
#
# $Id: one_day_script.pl,v 1.2 1998/04/29 17:54:53 wralph Exp $
#
#  Script to scan a tcpdump compressed hourly file using a pre-defined
#  tcpdump script. Parameters are: Date as YYMMDDHH and script name.
#  
#  Written by Bill Ralph 3/20/98
#
# Set up some variables.
#
use Getopt::Long;
use POSIX qw(strftime);
#
$ENV{PATH} = "/bin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/logger";
$SITE="Site1";
$FILTER_DIR="/usr/local/logger/filters";
#
sub usage {
        print "Usage: one_day_script.pl [-n] -d SNIFDATE [-l LOGGER_LOCATION] -s SCRIPT.\n";
	exit 2;
}
#
#	Parse the parameters.
#
#
use Getopt::Long;
&GetOptions("n", \$no_lookup_flag, "d=s", \$snifdate, "l:s", \$SITE,
            "s=s", \$script);
##
#
#  Check parameter validity.
#
if ("$snifdate" eq "" or "$SITE" eq "" or $script eq "")
{
	usage();
}
$analyzer_dir="/LOG/$SITE";
#
#
# Reset the $subdir variable.
#
if ($snifdate ne "") {
#
#  Break up the "snifdate" into its useful components.
#
   $year=substr($snifdate,0,2);
   $mon=substr($snifdate,2,2) - 1;
   $mday=substr($snifdate,4,2);
   $subdir=strftime("%h%d", 0, 0, 0, $mday, $mon, $year, 0, 0, 0);
}
#
#  Set the no_lookup_flag to -n for tcpdump if it was specified on the calling
#  parameter list.
#
$no_lookup_flag = ($no_lookup_flag eq "1") ?"-n":"";
#
# Ready to start the work now, find the hourly data files.
#
#
#
chdir("${analyzer_dir}/${subdir}");
@files=<tcp.*.gz>;
#print STDOUT @files;
if ($files[0] eq "") {
#
#  No hourly files, they must have been already condensed into daily ones.
#
   @files=<day*.gz>;
}
foreach $file (@files) {
#   print STDOUT ("gunzip -c $file | tcpdump -r - -F $FILTER_DIR/$script\n");
   system("gunzip -c $file | tcpdump -r - -F $FILTER_DIR/$script");
}
