#!/bin/sh
# This is a shell archive (produced by GNU sharutils 4.2).
# To extract the files from this archive, save it to some FILE, remove
# everything before the `!/bin/sh' line above, then type `sh FILE'.
#
# Made on 1998-04-30 10:42 EDT by <wralph@apollo13.nswc.navy.mil>.
# Source directory was `/home/wralph/tmp'.
#
# Existing files will *not* be overwritten unless `-c' is specified.
#
# This shar contains:
# length mode       name
# ------ ---------- ------------------------------------------
#    530 -rw-rw-r-- README
#    945 -rw-rw-r-- config
#   1113 -rwxr-xr-x rotate.sh
#    963 -rwxr-xr-x start_logger.sh
#    380 -rwxr-xr-x stop_logger.sh
#
save_IFS="${IFS}"
IFS="${IFS}:"
gettext_dir=FAILED
locale_dir=FAILED
first_param="$1"
for dir in $PATH
do
  if test "$gettext_dir" = FAILED && test -f $dir/gettext \
     && ($dir/gettext --version >/dev/null 2>&1)
  then
    set `$dir/gettext --version 2>&1`
    if test "$3" = GNU
    then
      gettext_dir=$dir
    fi
  fi
  if test "$locale_dir" = FAILED && test -f $dir/shar \
     && ($dir/shar --print-text-domain-dir >/dev/null 2>&1)
  then
    locale_dir=`$dir/shar --print-text-domain-dir`
  fi
done
IFS="$save_IFS"
if test "$locale_dir" = FAILED || test "$gettext_dir" = FAILED
then
  echo=echo
else
  TEXTDOMAINDIR=$locale_dir
  export TEXTDOMAINDIR
  TEXTDOMAIN=sharutils
  export TEXTDOMAIN
  echo="$gettext_dir/gettext -s"
fi
touch -am 1231235999 $$.touch >/dev/null 2>&1
if test ! -f 1231235999 && test -f $$.touch; then
  shar_touch=touch
else
  shar_touch=:
  echo
  $echo 'WARNING: not restoring timestamps.  Consider getting and'
  $echo "installing GNU \`touch', distributed in GNU File Utilities..."
  echo
fi
rm -f 1231235999 $$.touch
#
if mkdir _sh18798; then
  $echo 'x -' 'creating lock directory'
else
  $echo 'failed to create lock directory'
  exit 1
fi
# ============= README ==============
if test -f 'README' && test "$first_param" != -c; then
  $echo 'x -' SKIPPING 'README' '(file already exists)'
else
  $echo 'x -' extracting 'README' '(text)'
  sed 's/^X//' << 'SHAR_EOF' > 'README' &&
This improvement was written by Adam Shostack <adam@netect.com>:
X
Haven't had time to go through the CID stuff in any detail, but I did
have some trouble bringing up the sensor with the scripts provided, so
I rewrote them.  There are now 4 scripts: start_logger, stop_logger,
rotate and config.  The config contains variables for the other
three.  Rotate is designed to be invoked out of cron or startup files;
it will see that the logger is not running, and invoke it (its similar
to tcpdump-driver).
X
Files are attached.
X
Adam
X
SHAR_EOF
  $shar_touch -am 0430104098 'README' &&
  chmod 0664 'README' ||
  $echo 'restore of' 'README' 'failed'
  if ( md5sum --help 2>&1 | grep 'sage: md5sum \[' ) >/dev/null 2>&1 \
  && ( md5sum --version 2>&1 | grep -v 'textutils 1.12' ) >/dev/null; then
    md5sum -c << SHAR_EOF >/dev/null 2>&1 \
    || $echo 'README:' 'MD5 check failed'
3882236f8a69d7059738041a40b174a2  README
SHAR_EOF
  else
    shar_count="`LC_ALL= LC_CTYPE= LANG= wc -c < 'README'`"
    test 530 -eq "$shar_count" ||
    $echo 'README:' 'original size' '530,' 'current size' "$shar_count!"
  fi
fi
# ============= config ==============
if test -f 'config' && test "$first_param" != -c; then
  $echo 'x -' SKIPPING 'config' '(file already exists)'
else
  $echo 'x -' extracting 'config' '(text)'
  sed 's/^X//' << 'SHAR_EOF' > 'config' &&
#DEBUG=1; export DEBUG
X
# Configuration
# If you want to run everything under something other than /, set BASE
BASE=/usr/local/logger
X
#
TCPDUMP=tcpdump
OS=`uname -s`;
if [ "$OS" = "Linux" ]
then
X   PERL=/usr/bin/perl
X   PROGLOC=/usr/local/logger/sensor
X   LOGPROG="/usr/sbin/$TCPDUMP"
X   IFACE="-i eth0"
X   GZIPPROG=/bin/gzip
X   GZIP="-c -f"
elif [ "$OS" = "SunOS" ]
then
X   PERL=/usr/local/bin/perl
X   PROGLOC=/usr/local/bin
X   LOGPROG=/usr/local/bin/$TCPDUMP
X   IFACE=""
X   GZIPPROG=/usr/local/bin/gzip
X   GZIP="-c -f"
fi
X
X
LOGEXPR='ip and not port 25 and not port 20'
X
PS=/bin/ps
GREP=/bin/grep
X
ERRORS=${BASE}/tmp/logger.out
X
#CID_BIN=${BASE}/usr/local/bin
CID_BIN=${BASE}/sensor/
LOGDIR=${BASE}/LOG
X
# *** Some shells don't do well with $LOGDIR/log.pid - they try to
# find a variable $'LOGDIR/log.pid'
X
LOGPID=${LOGDIR}/log.pid
TCPLOG=${LOGDIR}/tcp.`date '+%y%m%d%H'`.gz
X
X
export PERL PROGLOC LOGPROG LOGDIR LOGPID TCPLOG GZIPPROG GZIP
X
X
SHAR_EOF
  $shar_touch -am 0429152198 'config' &&
  chmod 0664 'config' ||
  $echo 'restore of' 'config' 'failed'
  if ( md5sum --help 2>&1 | grep 'sage: md5sum \[' ) >/dev/null 2>&1 \
  && ( md5sum --version 2>&1 | grep -v 'textutils 1.12' ) >/dev/null; then
    md5sum -c << SHAR_EOF >/dev/null 2>&1 \
    || $echo 'config:' 'MD5 check failed'
f776d8b1be9ed8cb92f2a1388699282a  config
SHAR_EOF
  else
    shar_count="`LC_ALL= LC_CTYPE= LANG= wc -c < 'config'`"
    test 945 -eq "$shar_count" ||
    $echo 'config:' 'original size' '945,' 'current size' "$shar_count!"
  fi
fi
# ============= rotate.sh ==============
if test -f 'rotate.sh' && test "$first_param" != -c; then
  $echo 'x -' SKIPPING 'rotate.sh' '(file already exists)'
else
  $echo 'x -' extracting 'rotate.sh' '(text)'
  sed 's/^X//' << 'SHAR_EOF' > 'rotate.sh' &&
#!/bin/sh
X
X. config
X
#DEBUG=1
X
if [ -s $LOGPID ]; then
X    [ $DEBUG ] && echo '-s check passed'
X    P=`cat $LOGPID`
X    if [ `ps $P > /dev/null` ]; then
X	[ $DEBUG ] && echo ps check failed
X	    echo "Network logger not running.  Invoking Starter script for you."
X	    exec ./start_logger.sh
X    fi
fi
X
# Only do this stuff if we're not already running.
X
# Rotate through the snif.date files.
[ $DEBUG ] && echo "Rotating Files"
[ -e $LOGDIR/snif.date.1 ] && cp $LOGDIR/snif.date.1 $LOGDIR/snif.date.2
[ -e $LOGDIR/snif.date.0 ] && cp $LOGDIR/snif.date.0 $LOGDIR/snif.date.1
X
X
# Stop running logger.
# There are no debugs in here because this is downtime for the sniffer,
# and represents time we're not sniffing.  When the analysis tools can
# handle it, we'll reverse the order of this stuff, so you start a new
# logger before stopping the old ones.
X
kill $P
cp -f $LOGDIR/snif.date   $LOGDIR/snif.date.0
echo `date '+%y%m%d%H'` > $LOGDIR/snif.date
$LOGPROG -w - $IFACE $LOGEXPR | $GZIPPROG > $TCPLOG &
X
X
[ $? ] && ( rm -f $LOGPID ;\
X $PS axu | $GREP $TCPDUMP | $GREP -v $GREP | awk '{print $2}' > $LOGPID)
X
X
X
X
SHAR_EOF
  $shar_touch -am 0429150498 'rotate.sh' &&
  chmod 0755 'rotate.sh' ||
  $echo 'restore of' 'rotate.sh' 'failed'
  if ( md5sum --help 2>&1 | grep 'sage: md5sum \[' ) >/dev/null 2>&1 \
  && ( md5sum --version 2>&1 | grep -v 'textutils 1.12' ) >/dev/null; then
    md5sum -c << SHAR_EOF >/dev/null 2>&1 \
    || $echo 'rotate.sh:' 'MD5 check failed'
1ae42851154b9029f940335554944e4a  rotate.sh
SHAR_EOF
  else
    shar_count="`LC_ALL= LC_CTYPE= LANG= wc -c < 'rotate.sh'`"
    test 1113 -eq "$shar_count" ||
    $echo 'rotate.sh:' 'original size' '1113,' 'current size' "$shar_count!"
  fi
fi
# ============= start_logger.sh ==============
if test -f 'start_logger.sh' && test "$first_param" != -c; then
  $echo 'x -' SKIPPING 'start_logger.sh' '(file already exists)'
else
  $echo 'x -' extracting 'start_logger.sh' '(text)'
  sed 's/^X//' << 'SHAR_EOF' > 'start_logger.sh' &&
#!/bin/sh
X
X. config
X
#DEBUG=1
X
if [ -s $LOGPID ]; then
X    [ $DEBUG ] && echo '-s check passed'
X    P=`cat $LOGPID`
X    if [ ! `ps $P > /dev/null` ]; then
X	[ $DEBUG ] && echo ps check passed.
X	echo "Network logger already running.  Use the rotate.sh program."
X	exit 1
X    fi
fi
X
# Only do this stuff if we're not already running.
X
# Rotate through the snif.date files.
[ $DEBUG ] && echo "Rotating Files"
[ -e $LOGDIR/snif.date.1 ] && cp $LOGDIR/snif.date.1 $LOGDIR/snif.date.2
[ -e $LOGDIR/snif.date.0 ] && cp $LOGDIR/snif.date.0 $LOGDIR/snif.date.1
[ -e $LOGDIR/snif.date   ] && cp $LOGDIR/snif.date   $LOGDIR/snif.date.0
X
# Assume that other scripts really want this.
[ $DEBUG ] && echo "Creating new snif.date file"
echo `date '+%y%m%d%H'` > $LOGDIR/snif.date
X
[ $DEBUG ] && echo "Invoking Logger"
$LOGPROG -w - $IFACE $LOGEXPR | $GZIPPROG > $TCPLOG &
X
[ $? ] && ( rm -f $LOGPID ;\
X $PS axu | $GREP $TCPDUMP | $GREP -v $GREP | awk '{print $2}' > $LOGPID)
X
X
X
X
SHAR_EOF
  $shar_touch -am 0429150598 'start_logger.sh' &&
  chmod 0755 'start_logger.sh' ||
  $echo 'restore of' 'start_logger.sh' 'failed'
  if ( md5sum --help 2>&1 | grep 'sage: md5sum \[' ) >/dev/null 2>&1 \
  && ( md5sum --version 2>&1 | grep -v 'textutils 1.12' ) >/dev/null; then
    md5sum -c << SHAR_EOF >/dev/null 2>&1 \
    || $echo 'start_logger.sh:' 'MD5 check failed'
c37c418da7ef3e32937058a00b3dda9c  start_logger.sh
SHAR_EOF
  else
    shar_count="`LC_ALL= LC_CTYPE= LANG= wc -c < 'start_logger.sh'`"
    test 963 -eq "$shar_count" ||
    $echo 'start_logger.sh:' 'original size' '963,' 'current size' "$shar_count!"
  fi
fi
# ============= stop_logger.sh ==============
if test -f 'stop_logger.sh' && test "$first_param" != -c; then
  $echo 'x -' SKIPPING 'stop_logger.sh' '(file already exists)'
else
  $echo 'x -' extracting 'stop_logger.sh' '(text)'
  sed 's/^X//' << 'SHAR_EOF' > 'stop_logger.sh' &&
#!/bin/sh
X
X. config
X
DEBUG=1
X
if [ -s $LOGPID ]; then
X    [ $DEBUG ] && echo '-s check passed'
X    P=`cat $LOGPID`
X    if [ `ps $P > /dev/null` ]; then
X	[ $DEBUG ] && echo ps check failed
X	    echo "Network logger not running."  
X	    exit 1
X    fi
fi
X
[ ! $P ] && P=`$PS axu | $GREP $TCPDUMP | $GREP -v $GREP | awk '{print $2}'`
X
# Stop running logger.
X
kill $P
X
X
X
rm -f $LOGPID
SHAR_EOF
  $shar_touch -am 0427093598 'stop_logger.sh' &&
  chmod 0755 'stop_logger.sh' ||
  $echo 'restore of' 'stop_logger.sh' 'failed'
  if ( md5sum --help 2>&1 | grep 'sage: md5sum \[' ) >/dev/null 2>&1 \
  && ( md5sum --version 2>&1 | grep -v 'textutils 1.12' ) >/dev/null; then
    md5sum -c << SHAR_EOF >/dev/null 2>&1 \
    || $echo 'stop_logger.sh:' 'MD5 check failed'
18a9b18f368960b101b0c350315275ba  stop_logger.sh
SHAR_EOF
  else
    shar_count="`LC_ALL= LC_CTYPE= LANG= wc -c < 'stop_logger.sh'`"
    test 380 -eq "$shar_count" ||
    $echo 'stop_logger.sh:' 'original size' '380,' 'current size' "$shar_count!"
  fi
fi
rm -fr _sh18798
exit 0
